# txn commit

`

###

    txn commit
    	[-nosync]
    	[-sync]

# Description

The txn commit command ends the transaction.

In the case of nested transactions, if the transaction is a parent transaction with unresolved (neither committed or aborted) child transactions, the child transactions are aborted and the commit of the parent will succeed.

In the case of nested transactions, if the transaction is a child transaction, its locks are not released, but are acquired by its parent. While the commit of the child transaction will succeed, the actual resolution of the child transaction is postponed until the parent transaction is committed or aborted, i.e., if its parent transaction commits, it will be committed, and if its parent transaction aborts, it will be aborted.

If the -nosync option is not specified, a commit log record is written and flushed to disk, as are all previously written log records.

The options are as follows:

-nosync
  Do not synchronously flush the log. This means the transaction will exhibit the ACI (atomicity, consistency and isolation) properties, but not D (durability), i.e., database integrity will be maintained but it is possible that this transaction may be undone during recovery instead of being redone.

  This behavior may be set for an entire Berkeley DB environment as part of the berkdb env interface.

-sync
  Synchronously flush the log. This means the transaction will exhibit all of the ACID (atomicity, consistency and isolation and durability) properties.

  This behavior is the default for Berkeley DB environments unless the -nosync option was specified to the berkdb env or env txn interfaces.

The txn commit command returns 0 on success, and in the case of error, a Tcl error is thrown.

`

Copyright Sleepycat Software